#!/usr/bin/python3
# -*- coding: UTF-8 -*-

## masterGeo_always.py

#############################################################################
# Copyright (C) Labomedia December 2013
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################

from bge import logic as gl
from bge import render

def master_always_main():
    scene = gl.getCurrentScene()
    objList = scene.objects
    cam = scene.active_camera
    center = objList["Center"]
    terre  = objList["Terre"]
    france = objList["France"]
    
    #FPS(cam)
    terre_rot(center, terre)
    terre_or_france(terre, france, cam, center)

def terre_or_france(terre, france, cam, center):
    d = distance_cam_terre(cam, center)
    if d < 360:
        terre.worldPosition[2] = -2000
        france.worldPosition[2] = 0
    else:
        terre.worldPosition[2] = 0
        france.worldPosition[2] = -2000
    
def terre_rot(center, terre):
    mouse = gl.mouse
    H = 0.5 * (0.5 - mouse.position[0])
    V = 0.5 * (0.5 - mouse.position[1])
    dH = H - gl.mouse_position[0]
    dV = V - gl.mouse_position[1]
    
    if terre["left button"]:
        center.applyRotation([0, 0, dH], True)
        center.applyRotation([0, dV, 0], False)
        
    gl.mouse_position = H, V
    
def distance_cam_terre(cam, center):
    c = cam.worldPosition
    ct = center.worldPosition
    d = ((ct[0] - c[0])**2 + (ct[1] - c[1])**2 + (ct[2] - c[2])**2 )**0.5
    return d
    
def FPS(cam):
    mouse = gl.mouse
    Hrot = 0.5 * (0.5 - mouse.position[0])
    if -0.002 < Hrot < 0.002:
        Hrot = 0
    #cam.applyRotation([0, 0, Hrot], local=False)
    cam.applyRotation([0, 0, Hrot], False)

    Vrot = 0.5 * (0.5 - mouse.position[1])
    if -0.001 < Vrot < 0.001:
        Vrot = 0
    # radians
    cam.applyRotation([Vrot, 0, 0], True)
    
    # Center the mouse
    render.setMousePosition(int(render.getWindowWidth() / 2),
                                int(render.getWindowHeight() / 2))
